/*
13-12-2013
pour voir le contenu du fichier SAUVE003.TXT
notetablight Options Files Filter Binary Codes

Sur PC Asus 
Erase complete du fichier SAUVE003.txt avec caractere espace=32  taille 250Ko
idem pour SAUV001.TXT et SAUVE002.TXT




rev 12/12/2013
Rajout de fichiers sur la carte 3Gb via PC Asus
SAUVE001.TXT    183Ko
SAUVE002.TXT    183Ko
SAUVE003.TXT    802Ko

rev 11/12/2013
Essai de listing directory ..OK  2 fichier txt presents
Essai ecriture de 96 octets sur secteur 1 ..OK
Essai ecriture 511 bytes dans secteur 3 ..OK
relecture secteur 3 .. OK



rev 11-12-2013
1er essai
PIC18F26k22 Q=10Mhz ..is online...
Initializing SD-card Sandisk 2GB.
Erreur Init SD-Card 1 au pas 0

formattage SDCard sur PC Asus : Fat32 et secteur de 512 bytes.

2em essai
saute par dessus le test de presence SDcard car pas d'info dessus!
PIC18F26k22 Q=10Mhz ..is online...
Initializing SD-card Sandisk 2GB.
SD-card initalized.
Attempting to mount file system.
Attempting to open file TESTFILE.TXT. -> OK 
FResult = 3 Erreur essai ouverture de TESTFILE.TXT  au pas 1
nota , il n'y a pas de fichier sur la carte SD !!

Sur le PC Asus , transfer du fichier  TESTFILE.TXT de 32 octets sur la carte SD ..

3em essai OK pour la lecture !
voir SDcard_1312101.log

PIC18F26k22 Q=10Mhz ..is online...
Initializing SD-card Sandisk 2GB.
SD-card initalized.
Attempting to mount file system.
Attempting to open file TESTFILE.TXT. -> OK 
Starting to read the file.
Hello,Ceci est un texte de tst
...
Date: 10/12/2013 - 18:08:12
  
 * rev PF 10 dec 2013
 * Project name:fatfs.mcp
 * Copyright:
     (c) Jonas Andersson (jonas@haksberg.net) 2009
 * Revision History:
 	 - use of 18F26K22
 * Description:
 * Test configuration:
     MCU:             PIC18F26k22
     Dev.Board:       bread board
     Oscillator:      HS 10.000 MHz  (raised with PLL to 40.000MHz)
     
 * Language tool versions: 
     MPLAB           8.92.00.00
     MPASMWIN.exe v5.47
     MPLINK 4.45, Linker
     MCC18.exe v3.44
     mplib.exe v4.45
     MP2HEX 4.45 COFF to HEX File Converter
     MPPICkit3       1.0.1.71 
  
  * NOTES:
    Platine support SD-CARD mininthebox Module SD Card #00407346  3.67
                                    //      4 VCC 3.3V  (internal from voltage regulator 5V -> 3,3V)
                                    // 1--- 6 VSS Alim 5V DC
                                    // 6----3 VSS
#define SD_CS 	 PORTCbits.RC0	 -> // 5----1 CS        SD Card pins
#define SD_DO	 PORTCbits.RC5	 -> // 4----2 DI   MOSI
#define SD_DI	 PORTCbits.RC4	 <- // 2----7 DO   MISO
#define SD_CLCK	 PORTCbits.RC3	 -> // 3----5 CLCK
#define SD_WP	PORTCbits.RC2		// Card Write Protect ???
#define SD_CD	PORTAbits.RA3		// Card Detect


*/

/** INCLUDES ***************************************************/
#include <p18cxxx.h>
#include <delays.h>
#include <stdlib.h>
#include <stdio.h>
#include <usart.h>
//#include "Compiler.h"
#include "GenericTypeDefs.h"
#include "HardwareProfile.h"
#include "FatFs/pff.h"
#include "FatFs/diskio.h"

//#include "18f26k22_SD.lkr"

#include "p18f26k22.h"

#define p18f26k22

// config dans le code

// voir Help
//  Topics
//        Pic18
//            config bits settings
//                    choisir PIC18F26K22
#ifdef OSCILLATEUR_INTERNE
#pragma config FOSC = INTIO67, FCMEN = OFF, PLLCFG=OFF            // CONFIG1H
#else
#pragma config FOSC = HSMP, PLLCFG=ON, PRICLKEN=ON ,FCMEN=OFF      // quartz 10Mhz
#endif
#pragma config IESO=OFF,PWRTEN=OFF,BOREN=OFF,WDTEN=OFF,CCP2MX=PORTC1
#pragma config PBADEN=OFF,T3CMX=PORTC0,P2BMX=PORTC0,CCP3MX=PORTB5
#pragma config MCLRE=EXTMCLR,STVREN=OFF,LVP=ON,XINST=OFF,DEBUG=OFF
#pragma config CP0 = OFF, CP1 = OFF, CP2 = OFF, CP3 = OFF                    // CONFIG5Lhello
#pragma config CPB = OFF, CPD = OFF                                          // CONFIG5H
#pragma config WRT0 = OFF, WRT1 = OFF, WRT2 = OFF, WRT3 = OFF                // CONFIG6L
#pragma config WRTB = OFF, WRTC = OFF, WRTD = OFF                            // CONFIG6H
#pragma config EBTR0 = OFF, EBTR1 = OFF, EBTR2 = OFF, EBTR3 = OFF            // CONFIG7L
#pragma config EBTRB = OFF                                                   // CONFIG7H


#pragma udata BigBuffer
static BYTE sector_buffer[767];
#pragma

#pragma udata

unsigned int i,j,k;
BYTE  pas;
unsigned long Ticks;
int Seconds;
unsigned long pointeur;

FATFS fs;
DWORD fileSize;
BYTE data_buffer_32[32];
WORD reste;

volatile BYTE rtcYear = 109, rtcMon = 6, rtcMday = 21, rtcHour, rtcMin, rtcSec;

void HighPriorityISRCode();
void LowPriorityISRCode();
void ProcessIO(void);
void HardwareInit(void);
void BlinkSeconds(void);
void PrintSectorData(BYTE*);
void printhex(BYTE);
void Init_UART1(void);
void Put_RS( unsigned char  untel);
void PutStr_RS( unsigned char *s);
void PutStrR_RS(rom unsigned char *s);
void PutR_RS( rom unsigned char * untel);





FRESULT scan_files (BYTE* path);
DWORD get_fattime(void);

/*******************************************/

#pragma code HIGH_INTERRUPT_VECTOR = 0x08
void Remapped_High_ISR (void)
{
  _asm goto HighPriorityISRCode _endasm
	}
	#pragma code LOW_INTERRUPT_VECTOR = 0x18
	void Remapped_Low_ISR (void)
	{
	     _asm goto LowPriorityISRCode _endasm
}
#pragma code

#pragma interrupt HighPriorityISRCode
void HighPriorityISRCode()
{
}
	
#pragma interruptlow LowPriorityISRCode
void LowPriorityISRCode()
{	
static const BYTE months[12] = {31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31};
static UINT div1k;
BYTE n;
// TMR2 Interrupt?
	if( PIR1bits.TMR2IF && PIE1bits.TMR2IE )
	{
	// Clear Interruptflag
	PIR1bits.TMR2IF = 0;
	// Increase Tick counter
	Ticks++;
	/* Real Time Clock */
		if (++div1k >= 1000u) {
			div1k = 0;
			Seconds++;
			if (++rtcSec >= 60u) {
				rtcSec = 0;
				if (++rtcMin >= 60u) {
					rtcMin = 0;
					if (++rtcHour >= 24u) {
						rtcHour = 0;
						n = months[rtcMon - 1];
						if ((n == 28u) && !(rtcYear & 3u)) n++;
				    		if (++rtcMday > n) {
								rtcMday = 1;
								if (++rtcMon > 12u) {
									rtcMon = 1;
									rtcYear++;
								}
							}
						}
					}
				}
			}
			
		disk_timerproc();
	}	
}

#pragma code

// File to read 
BYTE fileName[32]={"TESTFILE.TXT"}; 
BYTE folder[48] = {""};


void Init_UART1(void)
{
// USART_BRGH_HIGH,6  @ 1MHZ     
// USART_BRGH_HIGH,32 @ 10MHZ 
// USART_BRGH_HIGH,51 @ 16MHZ 
// USART_BRGH_HIGH,25 @ 8MHZ 
// init 19200Bd a 10Mhz avec IT en rx
// init 38400Bd a 20Mhz 
// voir para 18.5 spec sheet DS41159B page 186
/*#ifdef OSCILLATEUR_INTERNE
OSCCON=0b01110000;  //HFINTOSC  (16 MHz)
//111 = HFINTOSC  (16 MHz)
//110 = HFINTOSC/2  (8 MHz)
//101 = HFINTOSC/4  (4 MHz)
//100 = HFINTOSC/8  (2 MHz)
//011 = HFINTOSC/16  (1 MHz)(3)
#endif
*/
Open1USART( USART_TX_INT_OFF &
USART_RX_INT_ON &
USART_ASYNCH_MODE &
USART_EIGHT_BIT &
USART_CONT_RX &
USART_BRGH_HIGH,130 );  // Q=10Mhzx 4(PLL)=40Mhz  19200bds
//USART_BRGH_HIGH,65 );  // Q=20Mhz  19200bds
//#ifdef OSCILLATEUR_INTERNE
// USART_BRGH_HIGH,13 );     // 4Mhz 19200 a 6% erreur
//USART_BRGH_HIGH,51 ); // 16MHz interne BRG16=0  19200bds sans PLL
// USART_BRGH_HIGH,25    // 16MHz interne BRG16=0  38400bds
// USART_BRGH_HIGH,208  // 16MHzxPLL soit 64Mhz  interne BRG16=0  19200bds
// USART_BRGH_HIGH,65  // Q=20Mhz  19200bds
//#else
//  USART_BRGH_HIGH,32 );  // Q=10Mhz 19200bds
//#endif
}

void Put_RS( unsigned char  untel)
{
   	while(Busy1USART());
   	Write1USART(untel);
}

void PutStr_RS( unsigned char *s)
{
	int n;
	for (n = 0; *s; n++, s++)
	{
       	Put_RS(*s);
     	}
}

void PutStrR_RS(rom unsigned char *s)
{
int n;
	for (n = 0; *s;n++ , s++)
	{
       	Put_RS(*s);
   	}
}

void PutR_RS( rom unsigned char * untel)
{
   	while(Busy1USART());
   	Write1USART(untel);
}

void CRLF()
{
    	PutStrR_RS((const rom char*)"\r\n");
}
    	

void Tempo(long L)
{
    while (L-->0);
}    

void HardwareInit()
{
    ANSELB=0;  // no Analog
    // Enable internal PORTB pull-ups
    TRISB = 0b00000011;   // LCD CTRL on RB2,RB3   LCD Data RB4...RB7
    INTCON2bits.RBPU = 0;
    ANSELC=0;      // no analog
    TRISC = 0b10000010;    // all output expect RC0,RC1,RC7
        
	/** I/O-ports **/
	// DDR
    SD_CS_TRIS = OUTPUT_PIN;		// SD chip select (inv)
	SD_WP_TRIS = INPUT_PIN;			// Card Write Protect (inv)
	SD_CD_TRIS = INPUT_PIN;			// Card Detect (inv)
	
	SPI_SCK_TRIS = OUTPUT_PIN;		// SPI-SCK
	SPI_MISO_TRIS = INPUT_PIN; 		// SPI-MISO	
	SPI_MOSI_TRIS = OUTPUT_PIN;		// SPI-MOSI
	
	LED1_TRIS = OUTPUT_PIN;			// LED1
	LED2_TRIS = OUTPUT_PIN;			// LED2
	

	LED1 = 0;
	LED2 = 0;
	
	// All pins do digital
   ANSELA=0;   
   PORTA = 0xFF;
   ANSELAbits.ANSA0=1;   // RA0 analog input for Temper ext LM335  ANA voir page 154
   ANSELAbits.ANSA1=1;   // RA1 analog input for Temper int L35DZ
   ANSELAbits.ANSA2=1;   // RA2 analog input for LDR
   TRISA = 0b11101111 ;  // PORTA is RA0,RA1= analog input, RA2,RA3=input RA4,RA5=Digital output
 
	/** Init Tick Timer (Timer 2) **/
	// Turn Timer 2 off
	T2CONbits.TMR2ON = 0;
	
	// Prescaler at 4
	T2CONbits.T2CKPS1 = 0;
	T2CONbits.T2CKPS0 = 1;
	
	// Postscaler at 10
	T2CONbits.T2OUTPS3 = 1;
	T2CONbits.T2OUTPS2 = 0;
	T2CONbits.T2OUTPS1 = 0;
	T2CONbits.T2OUTPS0 = 1;
	
	// Preload
	PR2 = 250;
	
	/* Configure USART 
    TXSTA1 = 0x20;
    RCSTA1 = 0x90;

	// See if we can use the high baud rate setting
	#if ((GetPeripheralClock()+2*BAUD_RATE)/BAUD_RATE/4 - 1) <= 255
		SPBRG = (GetPeripheralClock() + 2 * BAUD_RATE) / BAUD_RATE / 4 - 1;
		TXSTA1bits.BRGH = 1;
	#else	// Use the low baud rate setting
		SPBRG = (GetPeripheralClock() + 8 * BAUD_RATE) / BAUD_RATE / 16 - 1;
	#endif
	
	*/
}

// Blink with a LED at 0,5Hz
void BlinkSeconds()
{
	if( Seconds & 1 )
		LED1 = 1;
	else
		LED1 = 0;
}	

void ProcessIO(void)
{   
	return;
}

/********************************************************************
 * Function:        void PrintSectorData( BYTE* data )
 * PreCondition:    None
 * Input:           Pointer to a 512 byte buffer
 * Output:          Humen readble data
 * Side Effects:    None
 * Overview:        Data is outputed in goups of 16 bytes per row
 *******************************************************************/
void PrintSectorData( BYTE* data )
{
	WORD k, px;

	for(k = 0; k < 512; k++)
	{
		printhex(data[k]);
		Put_RS(' ');
		
		if( ((k + 1) % 16) == 0)
		{
			Put_RS(' ');
			
			for(px = (k - 15); px <= k; px++)
			{
				if( ((data[px] > 33) && (data[px] < 126)) || (data[px] == 0x20) )
				{
					Put_RS(data[px]);
				}
				else
				{
					Put_RS('.');
				}	
			}
		
			Put_RS(13);
			Put_RS(10);
		}
	}
}

/********************************************************************
 * Function:        void printhex( BYTE i )
 * PreCondition:    None
 * Input:           8-bit variable
 * Output:          sends data as hex over USART
 *******************************************************************/
void printhex(BYTE i)
{
  	BYTE hi, lo;
  
  	hi = i & 0xF0;               // High nibble
  	hi = hi >> 4;
  	hi = hi + '0';
  	
  	if(hi > '9')
  		hi = hi + 7;
  		
  	lo = (i & 0x0F) + '0';       // Low nibble
  	
  	if(lo > '9')
  		lo = lo + 7;
   	Put_RS(hi);
  	Put_RS(lo);
}


/********************************************************************
 * Function:        FRESULT scan_files (char* path)
 * PreCondition:    None
 * Input:           makes a directory listing of all files on the SD-card
 * Output:          directory listin over USART
 * Overview:        http://elm-chan.org/fsw/ff/pf/readdir.html
 *******************************************************************/
FRESULT scan_files (char* path)
{
    FRESULT res;
    FILINFO fno;
    DIR dir;
    int i;

    res = pf_opendir(&dir, path);
    if (res == FR_OK) {
        i = strlen(path);
        for (;;) {
            res = pf_readdir(&dir, &fno);
            if (res != FR_OK || fno.fname[0] == 0) break;
            if (fno.fattrib & AM_DIR) {
                sprintf(&path[i], "/%s", fno.fname);
                res = scan_files(path);
                if (res != FR_OK) break;
                path[i] = 0;
            } else {
                printf("%s/%s\r\n", path, fno.fname);
            }
        }
    }
    return res;
}

/*---------------------------------------------------------*/
/* User Provided RTC Function for FatFs module             */
/*---------------------------------------------------------*/
/* This is a real time clock service to be called from     */
/* FatFs module. Any valid time must be returned even if   */
/* the system does not support an RTC.                     */
/* This function is not required in read-only cfg.         */
// Not really used in this project

DWORD get_fattime (void)
{
	DWORD tmr;
	BYTE INTCONold;
	INTCONold = INTCON;
	INTCONbits.GIEH = 0;
	INTCONbits.GIEL = 0;
	/* Pack date and time into a DWORD variable */
	tmr =  (((DWORD)rtcYear - 80) << 25)
			| ((DWORD)rtcMon << 21)
			| ((DWORD)rtcMday << 16)
			| (WORD)(rtcHour << 11)
			| (WORD)(rtcMin << 5)
			| (WORD)(rtcSec >> 1);
	
	INTCON = INTCONold;
	return tmr;
}






void main(void)
{   
	FRESULT Result;
	BYTE temp = 'A';
	BYTE txt[20];
	FRESULT FResult;
    Ticks = 0;
	Seconds = 0;

	HardwareInit();
	Tempo(200000L);
	
	Init_UART1();
	
	

	/** Interrupts **/
	// Enable interrupt priorities
	RCONbits.IPEN = 1;
	
	// Enable Timer 2 interrupt at low priority
	PIR1bits.TMR2IF = 0;	// Clear interrupt flag
	PIE1bits.TMR2IE = 1;	// Enable interrupt
	IPR1bits.TMR2IP = 0;	// Low priority
	
	// Disable RX interrupt
	PIR1bits.RCIF = 0;		// Clear interrupt flag
	PIE1bits.RCIE = 0;		// Disable interrupt
	IPR1bits.RCIP = 0;		// Low priority
	
	// Enable interrupts
	INTCONbits.GIEH = 1;	// Turn on high priority interrupts
	INTCONbits.GIEL = 1;	// Turn on low priority interrupts
	
	// Turn Timer 2 on
	T2CONbits.TMR2ON = 1;
	
	Put_RS(12); // cls
	Tempo(300000L);
    PutStrR_RS((const rom char*)"\r\n Test Petite FAT  rev 13/12/2013  Mplab C18\r\n");
	PutStrR_RS((const rom char*)" PIC18F26k22 Q=10Mhz x 4 (PLL) \r\nInit SD-card Sandisk 2GB.\r\n");
	
	// Initialize SD-card with FatFs diskio functions
	Result = disk_initialize();
	
	if( Result != RES_OK )
	{
    	k=fprintf(_H_USART,(const rom char*)" Erreur Init SD-Card %c au pas %c\n\r",Result + '0',pas+'0');  
 		while(1);
	} else {
		PutStrR_RS((const rom char*)" SD-card initialisee.\r\n");
	}
	
	
// lecture d'un morceau de fichier 
    pas=0;
	PutStrR_RS((const rom char*)" Essai de monter le system de fichier\r\n");
	FResult = pf_mount(&fs);
	if (FResult == FR_OK )
	{ 
		PutStrR_RS((const rom char*)" Montage systeme de fichier OK\r\n ");
		// do a directory listing and list all files on the SD-card
    	k=fprintf(_H_USART,(const rom char*)" Liste des fichiers : \n\r"); 
        scan_files(folder);

		pas=0;
		// open file
		FResult = pf_open(fileName);
	 	pas=1;
		if( FResult == FR_OK )
		{
			k=fprintf(_H_USART,(const rom char*)" Ouverture fichier %s  OK \n\r",fileName); 
				// read file and print it until it ends
			do
			{
				// Read 32 bytes from the file
				//	void* buff,	 Pointer to the read buffer (NULL:Forward data to the stream)*/
	            //  WORD btr,	 Number of bytes to read */
	            //  WORD* reste	 Pointer to number of bytes read */
				FResult = pf_read(
				    data_buffer_32,/*Pointer to the read buffer (NULL:Forward data to the stream)*/
				    32,            /* Number of bytes to read */
				    &reste            /*Pointer to number of bytes read */
				   );
				if( FResult == FR_OK )
				{
					k=fprintf(_H_USART,(const rom char*)" Lecture OK de 31 bytes.. reste=%5u OK \n\r",reste); 
					// PutStr_RS needs a C-string (NULL terminated)
					data_buffer_32[reste] = 0;
					PutStr_RS(data_buffer_32);
				}
				else
				{
   				 	k=fprintf(_H_USART,(const rom char*)" Erreur %c sur lecture de fichier %s  \n\r",FResult + 0x30,fileName);  
					while( 1 );
				}
			} while( reste == 31 );	// if the pf_Read reads less then 31 bytes the file has ended
		}
		else 
		{
 		k=fprintf(_H_USART,(const rom char*)" FResult = %c Erreur Ouverture Fichier %s  au pas %c\n\r",fileName,FResult + 0x30,pas+'0');  
      	while( 1 );
		}
	}
	else
	{
    	k=fprintf(_H_USART,(const rom char*)" Erreur %c , sur essai de monter le system de fichier \n\r",FResult + 0x30);
    	while( 1 );
	}
	 CRLF();
	
//******************************************
	
// le systeme de fichier est encore ouvert et mont
// Le fichier doit deja exister et avoir sa taille maximale
// preparation 	: remplissage de blancs ou zeros
//  
   // FResult=pf_mount(0); NE PAS DEMONTER LE SYSTEME DE FICHIER .pour acceder a un autre fichier

    strcpypgm2ram (fileName,"SAUVE003.TXT"); 
    k=fprintf(_H_USART,(const rom char*)"Essai Ouverture fichier %s   \n\r",fileName); 
    FResult = pf_open(fileName);
 	pas=1;
	if (FResult == FR_OK )
	{
	 k=fprintf(_H_USART,(const rom char*)" Ouverture fichier %s  OK \n\r",fileName); 
	 }
	 else 
	 {
     k=fprintf(_H_USART,(const rom char*)" FResult = %c Erreur Ouverture Fichier %s  au pas %c\n\r",FResult + 0x30,fileName,pas+'0');  
     while(1);
	}
    //FResult=pf_lseek(0);  // gives an error ?
    //k=fprintf(_H_USART,(const rom char*)" FResult = %c Deplace pointer au debut\n\r",FResult + 0x30);  
   
    j=0;
    for (i=0;i<511;i++) 
    {
        j=i & 0x00FF;
    sector_buffer[i]=(unsigned char)(j);
    }	
    k=fprintf(_H_USART,(const rom char*)" buffer initialis\n\r ");  
  
FResult=pf_write(sector_buffer,512,&reste);
	k=fprintf(_H_USART,(const rom char*)" FResult = %c Ecriture effective de %5d bytes sur %s \n\r",FResult + 0x30,&reste,fileName); 
	k=fprintf(_H_USART,(const rom char*)" Nouveau pointer de fichier = %lu \n\r",fs.fptr);
FResult=pf_write(sector_buffer,512,&reste);
	k=fprintf(_H_USART,(const rom char*)" FResult = %c Ecriture effective de %5d bytes sur %s \n\r",FResult + 0x30,reste,fileName); 
	k=fprintf(_H_USART,(const rom char*)" Nouveau pointer de fichier = %lu \n\r",fs.fptr);
FResult=pf_write(sector_buffer,512,&reste);
	k=fprintf(_H_USART,(const rom char*)" FResult = %c Ecriture effective de %5d bytes sur %s \n\r",FResult + 0x30,reste,fileName); 
	k=fprintf(_H_USART,(const rom char*)" Nouveau pointer de fichier = %lu \n\r",fs.fptr);
FResult=pf_write(sector_buffer,512,&reste);
	k=fprintf(_H_USART,(const rom char*)" FResult = %c Ecriture effective de %5d bytes sur %s \n\r",FResult + 0x30,reste,fileName); 
	k=fprintf(_H_USART,(const rom char*)" Nouveau pointer de fichier = %lu \n\r",fs.fptr);
FResult=pf_write(sector_buffer,512,&reste);
	k=fprintf(_H_USART,(const rom char*)" FResult = %c Ecriture effective de %5d bytes sur %s \n\r",FResult + 0x30,reste,fileName); 
	k=fprintf(_H_USART,(const rom char*)" Nouveau pointer de fichier = %lu \n\r",fs.fptr);
FResult=pf_write(sector_buffer,512,&reste);
	k=fprintf(_H_USART,(const rom char*)" FResult = %c Ecriture effective de %5d bytes sur %s \n\r",FResult + 0x30,reste,fileName); 
	k=fprintf(_H_USART,(const rom char*)" Nouveau pointer de fichier = %lu \n\r",fs.fptr);
FResult=pf_write(sector_buffer,512,&reste);
	k=fprintf(_H_USART,(const rom char*)" FResult = %c Ecriture effective de %5d bytes sur %s \n\r",FResult + 0x30,reste,fileName); 
	k=fprintf(_H_USART,(const rom char*)" Nouveau pointer de fichier = %lu \n\r",fs.fptr);
FResult=pf_write(sector_buffer,512,&reste);
	k=fprintf(_H_USART,(const rom char*)" FResult = %c Ecriture effective de %5d bytes sur %s \n\r",FResult + 0x30,reste,fileName); 
	k=fprintf(_H_USART,(const rom char*)" Nouveau pointer de fichier = %lu \n\r",fs.fptr);
	k=fprintf(_H_USART,(const rom char*)"\r\n Finalise ecriture = %lu \n\r",fs.fptr);
FResult=pf_write(0,0,&reste);
	k=fprintf(_H_USART,(const rom char*)"\r\n FResult = %c  inscription de %5d zeros \n\r",FResult + 0x30,reste);

		
	
	
	
// ***************************************
	
	// unmount drive
	PutStrR_RS((const rom char*)" Demontage du system de fichier...");
	FResult = pf_mount(NULL);
	if( FResult != FR_OK )
	{
    k=fprintf(_H_USART,(const rom char*)" Erreur %c  \n\r",FResult + 0x30);
	while( 1 );
	}	
	PutStrR_RS((const rom char*)"OK .\r\n");

  
//  voir Test_ecriture_lecture_512bytes.txt
// ecriture 96 bytes -> secteur 1 et relecture..OK
// ecriture 512 bytes sect 3  et relecture .OK

    while(1);
    {
	    // Blink with the LED at 1 Hz so we know if we are alive
	    BlinkSeconds();
       ProcessIO();    
    }
}

/*

1er essai
PIC18F26k22 Q=10Mhz ..is online...
Initializing SD-card Sandisk 2GB.
Erreur Init SD-Card 1 au pas 0

formattage SDCard sur PC Asus : Fat32 et secteur de 512 bytes.

2em essai
saute par dessus le test de presence SDcard car pas d'info dessus!
PIC18F26k22 Q=10Mhz ..is online...
Initializing SD-card Sandisk 2GB.
SD-card initalized.
Attempting to mount file system.
Attempting to open file TESTFILE.TXT. -> OK 
FResult = 3 Erreur essai ouverture de TESTFILE.TXT  au pas 1
nota , il n'y a pas de fichier sur la carte SD !!

transfer du fichier  TESTFILE.TXT de 32 octets sur la carte SD ..

3em essai OK pour la lecture !
Terminal log file
Date: 10/12/2013 - 18:06:23
-----------------------------------------------
Terminal log file
Date: 11/12/2013 - 18:59:40
-----------------------------------------------
   
 Test Petite FAT  rev 12/12/2013  Mplab C18
 PIC18F26k22 Q=10Mhz ..is online...
Init SD-card Sandisk 2GB.
 Erreur Init SD-Card 1 au pas 3

    
 Test Petite FAT  rev 12/12/2013  Mplab C18
 PIC18F26k22 Q=10Mhz ..is online...
Init SD-card Sandisk 2GB.
 Erreur Init SD-Card 1 au pas 3

 
 <0><0><0><0><0><0>
 Test Petite FAT  rev 12/12/2013  Mplab C18
 PIC18F26k22 Q=10Mhz ..is online...
Init SD-card Sandisk 2GB.
 SD-card initialisee.
 Essai de monter le system de fichier
 Montage systeme de fichier OK
  Liste des fichiers : 
/TESTFILE.TXT
/SAUVE001.TXT
/TRAME___.TXT
/SAUVE003.TXT
/SAUVE002.TXT
 Ouverture fichier TESTFILE.TXT  OK 
 Lecture OK de 31 bytes.. br=   32 OK 
Hello,Ceci est un texte de tst

Essai Ouverture fichier SAUVE003.TXT   
 Ouverture fichier SAUVE003.TXT  OK 
 buffer initialis
  FResult = 0 Ecriture effective de   512 bytes sur SAUVE003.TXT 
 Nouveau pointer de fichier = 512 
 FResult = 0 Ecriture effective de   512 bytes sur SAUVE003.TXT 
 Nouveau pointer de fichier = 1024 
 FResult = 0 Ecriture effective de   512 bytes sur SAUVE003.TXT 
 Nouveau pointer de fichier = 1536 
 FResult = 0 Ecriture effective de   512 bytes sur SAUVE003.TXT 
 Nouveau pointer de fichier = 2048 
 FResult = 0 Ecriture effective de   512 bytes sur SAUVE003.TXT 
 Nouveau pointer de fichier = 2560 
 FResult = 0 Ecriture effective de   512 bytes sur SAUVE003.TXT 
 Nouveau pointer de fichier = 3072 
 FResult = 0 Ecriture effective de   512 bytes sur SAUVE003.TXT 
 Nouveau pointer de fichier = 3584 
 FResult = 0 Ecriture effective de   512 bytes sur SAUVE003.TXT 
 Nouveau pointer de fichier = 4096 

 Finalise ecriture = 4096 

 FResult = 0  inscription de     0 zeros 
 Demontage du system de fichier...OK .
 
 voir Sandisk2G_sauve003.jpg
 
*/